summaryrefslogtreecommitdiff
path: root/tests/misc/mknod
diff options
context:
space:
mode:
Diffstat (limited to 'tests/misc/mknod')
-rwxr-xr-xtests/misc/mknod56
1 files changed, 56 insertions, 0 deletions
diff --git a/tests/misc/mknod b/tests/misc/mknod
new file mode 100755
index 0000000..12cb0a6
--- /dev/null
+++ b/tests/misc/mknod
@@ -0,0 +1,56 @@
+#!/bin/sh
+# Ensure that mknod, mkfifo, mkdir -m MODE work with a restrictive umask
+
+# Copyright (C) 2004, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ mknod --version
+fi
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+umask 777
+
+mknod -m 734 f1 p || fail=1
+set _ `ls -dgo f1`; shift; mode=$1
+test $mode = prwx-wxr-- || fail=1
+
+mkfifo -m 734 f2 || fail=1
+set _ `ls -dgo f2`; shift; mode=$1
+test $mode = prwx-wxr-- || fail=1
+
+mkdir -m 734 f3 || fail=1
+set _ `ls -dgo f3`; shift; mode=$1
+test $mode = drwx-wxr-- || test $mode = drwx-wsr-- || fail=1
+
+(exit $fail); exit $fail